<?php

namespace CADSUP\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Ger00800FornecedorInscricaoController extends \Zeedhi\Framework\Controller\Report
{

    protected $environment;
    protected $stNomeRel;
    protected $connection;
    protected $birtStrategy;

    public  function __construct($reportService, $connection, $birtStrategy, $environment)
    {
        parent::__construct($reportService);
        $this->connection    =   $connection;
        $this->birtStrategy  =   $birtStrategy;
        $this->environment   =   $environment;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $this->stNomeRel = $this->getReportName($row);
        $row['STRATEGY'] = 'BIRT';
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $row['NRORG'] = $this->environment->getNrOrg();
        $this->reportMapping[$this->stNomeRel] =
        array(
            'strategy' => $row['STRATEGY'],
            'parameterMapping' =>
            array (
                "L_CDFORNECED"      => 'P_CDFORNECED',
                "L_CDPAIS"          => 'P_CDPAIS',
                "L_SGESTADO"        => 'P_SGESTADO',
                "L_CDMUNICIPIO"     => 'P_CDMUNICIPIO',
                "L_CDTIPOFORN"      => 'P_CDTIPOFORN',
                "IDSITUCADA"        => 'P_IDSITUCADA',
                "IDTPENVAFFOR"      => 'P_IDTPENVAFFOR',
                "IDUTILEDINF"       => 'P_IDUTILEDINF',
                "NRORG"             => 'P_NRORG'
            )
        );
    }
}
