<?php

namespace Relatione\Logic;

use \Geral\Util\Ambiente;
/**
 * Created by JetBrains PhpStorm.
 * User: marcellichtnow
 * Date: 05/04/13
 * Time: 08:36
 * To change this template use File | Settings | File Templates.
 */
class ProspectLogic
{


    public static function insereEndProsp() {
        $db = \Setforms2\Runtime\Connection::getInstance();

        $cdProsp = tk_get_field_value('CDPROSPECT');

        //Verifica se o prospect setado ja possui algum endereço registrado
        $sqlVerificaEnd = "SELECT * FROM ENDEPROSPECT
                       WHERE CDPROSPECT = '$cdProsp'";
        $resultVerificaEnd = $db->fetchAll($sqlVerificaEnd);

        //Se não, insere um endereço pricipal padrão
        if ($resultVerificaEnd === false) {
            try {
                $sql = 'INSERT INTO ENDEPROSPECT
                    (CDPROSPECT,IDTPENDEPROS,CDPAIS,SGESTADO,NRORG,
                     NRORGINCLUSAO,NRORGULTATU,DTINCLUSAO,DTULTATU,
                     CDOPERINCLUSAO,CDOPERULTATU)
                    VALUES
                    (?,?,?,?,?,?,?,?,?,?,?)';

                $param = array($cdProsp,'P','0055','MG',Ambiente::getNrorg(),
                    Ambiente::getNrorg(),Ambiente::getNrorg(),now(),now(),
                    Ambiente::getCdOperador(),Ambiente::getCdOperador());

                $db->execute($sql, $param);

            } catch (\Exception $e) {
                return $e;
//                TkDebug::Message($e->getMessage());
            }
        }
        return true;
    }


    public static function geraCodigoProspect($nrOrg){
        $cdProspect = \Geral\Util\NovoCodigo::geraCodigo($nrOrg, 'PROSPECT', 21);

        //Codigo do prospect duplicado e sem zeros à esquerda
        $cdProspect = str_repeat(ltrim($cdProspect, '0'), 2);
        return $cdProspect;
    }


    public static function validateCNPJ($cnpj)
    {
        $cnpj = preg_replace("/[^0-9]/", "", $cnpj);
        if (strlen($cnpj) != 14) {
            return 0;
        }

        $soma = 0;

        $soma += ($cnpj[0] * 5);
        $soma += ($cnpj[1] * 4);
        $soma += ($cnpj[2] * 3);
        $soma += ($cnpj[3] * 2);
        $soma += ($cnpj[4] * 9);
        $soma += ($cnpj[5] * 8);
        $soma += ($cnpj[6] * 7);
        $soma += ($cnpj[7] * 6);
        $soma += ($cnpj[8] * 5);
        $soma += ($cnpj[9] * 4);
        $soma += ($cnpj[10] * 3);
        $soma += ($cnpj[11] * 2);

        $d1 = $soma % 11;
        $d1 = $d1 < 2 ? 0 : 11 - $d1;

        $soma = 0;
        $soma += ($cnpj[0] * 6);
        $soma += ($cnpj[1] * 5);
        $soma += ($cnpj[2] * 4);
        $soma += ($cnpj[3] * 3);
        $soma += ($cnpj[4] * 2);
        $soma += ($cnpj[5] * 9);
        $soma += ($cnpj[6] * 8);
        $soma += ($cnpj[7] * 7);
        $soma += ($cnpj[8] * 6);
        $soma += ($cnpj[9] * 5);
        $soma += ($cnpj[10] * 4);
        $soma += ($cnpj[11] * 3);
        $soma += ($cnpj[12] * 2);


        $d2 = $soma % 11;
        $d2 = $d2 < 2 ? 0 : 11 - $d2;

        if ($cnpj[12] == $d1 && $cnpj[13] == $d2) {
            return 1;
        } else {
            return 0;
        }
    }


    public static function validateCPF($cpf)
    {
        $nulos = array("12345678909", "11111111111", "22222222222", "33333333333",
            "44444444444", "55555555555", "66666666666", "77777777777",
            "88888888888", "99999999999", "00000000000");
        $cpf = preg_replace("/[^0-9]/", "", $cpf);
        if (!(preg_match("/[0-9]/", $cpf)))
            return 0;
        if (in_array($cpf, $nulos))
            return 0;
        if (strlen($cpf) != 11) {
            return 0;
        }
        $acum = 0;
        for ($i = 0; $i < 9; $i++) {
            $acum += $cpf[$i] * (10 - $i);
        }

        $x = $acum % 11;
        $acum = ($x > 1) ? (11 - $x) : 0;
        if ($acum != $cpf[9]) {
            return 0;
        }
        $acum = 0;
        for ($i = 0; $i < 10; $i++) {
            $acum += $cpf[$i] * (11 - $i);
        }

        $x = $acum % 11;
        $acum = ($x > 1) ? (11 - $x) : 0;
        if ($acum != $cpf[10]) {
            return 0;
        }

        return 1;
    }


    /*          */


    public static function retornaProspect($nrParceiro, $nrOrg){

        $prospect = \Geral\Entities\Prospect::getObjectByWhere(
            'NRPARCNEGOCIO = ? AND NRORG = ?',
            array(
                $nrParceiro,
                $nrOrg,
            )
        );
        return $prospect;

    }


    function mtk_ron_converte_string($field, $tab, $type = 'upper') {

        $fieldValue = tk_get_field_value($field);

        $type = strtolower($type);

        if ($fieldValue) {
            if (!is_numeric($fieldValue)) {
                if (($type === 'upper') || ($type === upper)) {

                    $fieldValue = strtoupper($fieldValue);
                    tk_set_field_value($field, $fieldValue);
                }
                elseif ($type === 'lower' || $type === lower) {

                    $fieldValue = strtolower($fieldValue);
                    tk_set_field_value ($field, $fieldValue);
                }
                elseif ($type === 'ucwords' || $type === ucwords) {

                    $fieldValue = ucwords($fieldValue);
                    tk_set_field_value($field, $fieldValue);
                }
                else {

                    tk_message('Parâmetro $type indefinido ou incorreto!');
                }
            }
            else {
                tk_message('Função não aplicada para valores numéricos!');
            }
        }
    }

}
