/*+
|                                               |
|     Trigger: DTULTATU_INTEPROSP               |  
|     Tabela : INTEPROSP                        |
|                                               |
|     Criao:                                  |
|     18/07/2007 - Danilo dos Anjos Faria       |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_INTEPROSP
BEFORE INSERT OR UPDATE OR DELETE
ON INTEPROSP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUINTP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF ((NVL(:OLD.CDPROSPECT,   0) <> NVL(:NEW.CDPROSPECT,  0)) OR
           (NVL(:OLD.CDPAIS,      0) <> NVL(:NEW.CDPAIS,      0)) OR
           (NVL(:OLD.SGESTADO,    0) <> NVL(:NEW.SGESTADO,    0)) OR
           (NVL(:OLD.CDMUNICIPIO, 0) <> NVL(:NEW.CDMUNICIPIO, 0)) OR
           (NVL(:OLD.IDTPINTEPROS,0) <> NVL(:NEW.IDTPINTEPROS,0)) OR
           (NVL(:OLD.NMINTEPROS,  0) <> NVL(:NEW.NMINTEPROS,  0)) OR
           (NVL(:OLD.DSCARGINPROS,0) <> NVL(:NEW.DSCARGINPROS,0)) OR          
           (NVL(:OLD.NRTEL1INPROS,0) <> NVL(:NEW.NRTEL1INPROS,0)) OR
           (NVL(:OLD.NRRAM1INPROS,0) <> NVL(:NEW.NRRAM1INPROS,0)) OR
           (NVL(:OLD.NRTEL2INPROS,0) <> NVL(:NEW.NRTEL2INPROS,0)) OR
           (NVL(:OLD.NRRAM2INPROS,0) <> NVL(:NEW.NRRAM2INPROS,0)) OR
           (NVL(:OLD.NRFAXINPROS, 0) <> NVL(:NEW.NRFAXINPROS, 0)) OR
           (NVL(:OLD.IDENDEINPROS,0) <> NVL(:NEW.IDENDEINPROS,0)) OR
           (NVL(:OLD.DSENDEINPROS,0) <> NVL(:NEW.DSENDEINPROS,0)) OR
           (NVL(:OLD.NMBAIRINPROS,0) <> NVL(:NEW.NMBAIRINPROS,0)) OR
           (NVL(:OLD.NRCEPINPROS, 0) <> NVL(:NEW.NRCEPINPROS, 0)) OR
           (NVL(:OLD.DSEMAILIPROS,0) <> NVL(:NEW.DSEMAILIPROS,0)) OR
           (NVL(:OLD.IDSTINTEPROS,0) <> NVL(:NEW.IDSTINTEPROS,0)) OR
           (NVL(:OLD.NRCELULINPRO,0) <> NVL(:NEW.NRCELULINPRO,0)) OR
           (NVL(:OLD.NRTELREINPRO,0) <> NVL(:NEW.NRTELREINPRO,0)) OR
           (NVL(:OLD.DTNASCINPROS,TO_DATE('31/12/1899','DD/MM/YYYY')) <> NVL(:NEW.DTNASCINPROS,TO_DATE ('31/12/1899','DD/MM/YYYY'))) OR
           (NVL(:OLD.CDINTEPROS,  0) <> NVL(:NEW.CDINTEPROS,  0))) THEN
           :NEW.DTULTATUINTP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
      VALUES ('INTEPROSP'  , '', 'CDPROSPECT='||:OLD.CDPROSPECT||';CDINTEPROS='||:OLD.CDINTEPROS||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE INTEPROSP MODIFY DTULTATUINTP DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_INTEPROSP','5.07.009'); END;
/

