create or replace PROCEDURE USR_PROT_IMPORTA_DEVOCOMPRA(
   P_MENSAGEMERRO OUT VARCHAR2)
IS
   --GERAL
   V_CDCENTCUST	USR_CISDEVO_COMPRA.CDCENTCUST%TYPE;
   V_NRAUTOFORNE	USR_CISDEVO_COMPRA.NRAUTOFORNE%TYPE;
   V_CDFORNECED	USR_CISDEVO_COMPRA.CDFORNECED%TYPE;
   V_NRNOTAFISCAL	USR_CISDEVO_COMPRA.NRNOTAFISCAL%TYPE;
   V_DTSAIDA 		USR_CISDEVO_COMPRA.DTSAIDA%TYPE;
   V_DTEMISSAO 	USR_CISDEVO_COMPRA.DTEMISSAO%TYPE;
   V_CDSERIE		USR_CISDEVO_COMPRA.CDSERIE%TYPE;
   --PRODUTO
   V_CDPRODUTO 	USR_CISDEVO_COMPRA.CDPRODUTO%TYPE;
   V_VRQUANTIDADE	USR_CISDEVO_COMPRA.VRQUANTIDADE%TYPE;
   V_VRQUANTAT 	USR_CISDEVO_COMPRA.VRQUANTAT%TYPE;
   V_VRUNITARIO	USR_CISDEVO_COMPRA.VRUNITARIO%TYPE;
   --AF
   V_CDMARCA		ITEMAUTF.CDMARCA%TYPE;
   V_DTPROGENTAF	ITEMAUTF.DTPROGENTAF%TYPE;
   V_VRPREUNIAF	ITEMAUTF.VRPREUNIAF%TYPE;
   V_QTPROGENTAF	ITEMAUTF.QTPROGENTAF%TYPE;

   --ESPECIFICO TABELA INT
   V_IDINTERFACE	 VARCHAR2(1);
   V_LOG_ERRO      VARCHAR2(250);
   V_DTGRAVACAO    DATE;
   V_HRGRAVACAO    VARCHAR2(5);
   V_DTIMPORTACAO  DATE;
   V_HRIMPORTACAO  VARCHAR2(5);
   V_ERRO 		    VARCHAR2(5000);
   V_OBS			    VARCHAR2(5000);

   --VARIAVEIS LOCAIS MUTAVEIS
   --NOTAFISCAL/CABECALHO
   V_CDEMPRESA 	FILIAL.CDEMPRESA%TYPE;
   V_CDINSCESTA	FILIAL.CDINSCESTA%TYPE;
   V_CDINSCMUNI	FILIAL.CDINSCMUNI%TYPE;
   V_IDTPIJURNF	NOTAFISCAL.IDTPIJURNF%TYPE;
   V_NRINSJURNF	NOTAFISCAL.NRINSJURNF%TYPE;
   V_NRAUTOFORN	AUTOFORNE.NRAUTOFORN%TYPE;

   -- LANCTOEST/PRODUTOS
   V_NRSEQUITEM	  VARCHAR2(4);
   V_PRODEMIS		  ITEMPRODUTO.CDPRODEMIS%TYPE;
   V_DSPRODEMIS	  ITEMPRODUTO.DSPRODEMIS%TYPE;
   V_VRTOTLANCTO	  FLOAT(126);
   V_VRTOTALITEM	  FLOAT(126);
   V_NRLANCTONF	  NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_NRLANCESTQ	  NOVOCODIGO.NRSEQUENCIAL%TYPE;
   P_IDERROAF		  VARCHAR2(1);
   V_COUNT 		     NUMBER;
   V_NRSEQDEVOL     VARCHAR2(4);
   V_CDFILIALIT     NOTAFISCAL.CDFILIAL%TYPE;
   V_NRLANCTONFIT   NOTAFISCAL.NRLANCTONF%TYPE;

   --OUTRAS
   V_FORNECEDOR	FORNECEDOR.CDFORNECED%TYPE;
   V_CDFILIAL		FILIAL.CDFILIAL%TYPE;

   CURSOR C_NOTAS IS
      SELECT DISTINCT CDCENTCUST, NRAUTOFORNE, CDFORNECED, NRNOTAFISCAL, DTSAIDA, DTEMISSAO, CDSERIE, IDINTERFACE,
             LOG_ERRO, DTIMPORTACAO, HRIMPORTACAO
        FROM USR_CISDEVO_COMPRA
       WHERE DTIMPORTACAO IS NULL;

   CURSOR C_PRODUTONF(C_CDCENTCUST IN VARCHAR2, C_NRNOTAFISCAL IN VARCHAR2, C_CDFORNECED IN VARCHAR2) IS
      SELECT USR.CDPRODUTO, VRQUANTIDADE, VRQUANTAT, VRUNITARIO,
             CDMARCA, DTPROGENTAF, VRPREUNIAF
        FROM USR_CISDEVO_COMPRA USR, ITEMAUTF IT
       WHERE USR.DTIMPORTACAO IS NULL
         AND USR.CDCENTCUST   = C_CDCENTCUST
         AND USR.NRNOTAFISCAL = C_NRNOTAFISCAL
         AND USR.CDFORNECED   = C_CDFORNECED
         AND IT.NRAUTOFORN    = LPAD(USR.NRAUTOFORNE, 10, '0')
         AND IT.CDPRODUTO     = USR.CDPRODUTO;
BEGIN
   V_OBS  := NULL;
   P_MENSAGEMERRO := NULL;

   OPEN C_NOTAS;
   LOOP
      FETCH C_NOTAS INTO V_CDCENTCUST,
                         V_NRAUTOFORNE,
                         V_CDFORNECED,
                         V_NRNOTAFISCAL,
                         V_DTSAIDA,
                         V_DTEMISSAO,
                         V_CDSERIE,
                         V_IDINTERFACE,
                         V_LOG_ERRO,
                         V_DTIMPORTACAO,
                         V_HRIMPORTACAO;
      EXIT WHEN C_NOTAS%NOTFOUND;

      V_ERRO := NULL;
      V_NRAUTOFORN := LPAD(V_NRAUTOFORNE, 10, '0');

      SELECT CDFILIAL INTO V_CDFILIAL FROM PARAMFILIAL WHERE CDEXFILIAL = V_CDCENTCUST;

      V_COUNT := 0;
      V_VRTOTLANCTO := 0;
      NOVO_CODIGO_SC('LANCNF/FILIAL'||V_CDFILIAL, V_NRLANCTONF);
      V_NRLANCTONF := SUBSTR(V_NRLANCTONF, 11, 10);
      NOVO_CODIGO_SC('LANCTOEST'||V_CDFILIAL, V_NRLANCESTQ);
      V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ, 11, 10);

      SELECT CDEMPRESA, CDINSCESTA, CDINSCMUNI
        INTO V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI
        FROM FILIAL
       WHERE CDFILIAL = V_CDFILIAL;

      SELECT CDFORNECED
        INTO V_FORNECEDOR
        FROM FORNECEDOR
       WHERE CDEXFORNECED = V_CDFORNECED;

      SELECT IDTPIJURFORN, NRINSJURFORN
        INTO V_IDTPIJURNF, V_NRINSJURNF
        FROM FORNECEDOR
       WHERE CDFORNECED = V_FORNECEDOR;

      SELECT SUM(VRQUANTIDADE * VRUNITARIO)
        INTO V_VRTOTLANCTO
        FROM USR_CISDEVO_COMPRA
       WHERE CDCENTCUST   = V_CDCENTCUST
         AND NRNOTAFISCAL = V_NRNOTAFISCAL
         AND CDFORNECED   = V_CDFORNECED
       GROUP BY NRNOTAFISCAL;

      BEGIN
         INSERT INTO NOTAFISCAL
            (CDFILIAL, NRLANCTONF, CDFILIRECE, CDEMPRESA, CDINSCESTA, CDSERIE, CDINSCMUNI,
             IDTPIJURNF, NRINSJURNF, CDFORNECED, IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
             NRNOTAFISC, DTEMISSAO, DTENTRSAID, VRPRODUTOS, VRNOTAFISC, IDENTRSAIDOP,
             CDTIPOOPER, CDSERIEENTR, CDCLIENTE, CDFILIEMIT, IDORIGDESTNF, IDSTATUS)
         VALUES
            (V_CDFILIAL, V_NRLANCTONF, V_CDFILIAL, V_CDEMPRESA, V_CDINSCESTA, V_CDSERIE, V_CDINSCMUNI,
             V_IDTPIJURNF, V_NRINSJURNF, V_FORNECEDOR, 'N', 'N', 'S',
             LPAD(V_NRNOTAFISCAL, 9, '0'), V_DTEMISSAO, V_DTSAIDA, V_VRTOTLANCTO, V_VRTOTLANCTO, 'S',
             '10', V_CDSERIE, NULL, NULL, 'F', 'A');

         INSERT INTO LANCTOESTOQ
            (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, IDALTCUSMED,
             NRLANCTONF, CDFILIMOVI, CDOPERADOR)
         VALUES
            (V_CDFILIAL, V_NRLANCESTQ, '4', V_DTSAIDA, 'INTEGRACAO DEVOLUO NF: '||LPAD(V_NRNOTAFISCAL, 9, '0')||' AF: '||V_NRAUTOFORN, 'S',
             V_NRLANCTONF, V_CDFILIAL, '000000009999'); -- CRIAR OPERADOR PARA INTEGRACAO?

      EXCEPTION
         WHEN OTHERS THEN
            V_ERRO := SQLERRM(SQLCODE);
            P_MENSAGEMERRO := V_ERRO;
      END;

      OPEN C_PRODUTONF(V_CDCENTCUST, V_NRNOTAFISCAL, V_CDFORNECED);
      LOOP
         FETCH C_PRODUTONF INTO V_CDPRODUTO,
                                V_VRQUANTIDADE,
                                V_VRQUANTAT,
                                V_VRUNITARIO,
                                V_CDMARCA,
                                V_DTPROGENTAF,
                                V_VRPREUNIAF;
         EXIT WHEN C_PRODUTONF%NOTFOUND;

         SELECT NMPRODUTO INTO V_DSPRODEMIS FROM PRODUTO WHERE CDPRODUTO = V_CDPRODUTO;

         IF (V_IDINTERFACE = '1') THEN

            SELECT MAX(LE.CDFILIAL), MAX(LE.NRLANCTONF)
              INTO V_CDFILIALIT, V_NRLANCTONFIT
              FROM USR_CISORDEM_COMPRA OC, LANCTOESTOQ LE
             WHERE OC.NRAUTOFORNE = V_NRAUTOFORNE
               AND OC.NRLANCESTQ = LE.NRLANCESTQ;

            SELECT LPAD(TO_CHAR(NVL(MAX(NRSEQUITNOTA),0)), 3, '0')
              INTO V_NRSEQDEVOL FROM ITEMNOTAFISC
             WHERE CDFILIAL = V_CDFILIALIT
               AND NRLANCTONFIT = V_NRLANCTONFIT;

            V_COUNT := V_COUNT +1;
            V_NRSEQUITEM := LPAD(TO_CHAR(V_COUNT), 4, '0');

            V_VRTOTALITEM := V_VRQUANTIDADE * V_VRUNITARIO;

            BEGIN
               INSERT INTO ITEMPRODUTO
                  (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO,
                   CDPRODEMIS, DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                   VRUNITITEM, VRDESCITEM, VRTOTAITEM, VRCONTITEM,
                   VRBRUTITEM, IDCONFORITEM, CDFILIMOVI,
                   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                   CDPRODMOVI, NRAUTOFORN, CDMARCA, DTPROGENTAF)
               VALUES
                  (V_CDFILIAL, V_NRLANCTONF, V_NRSEQUITEM, V_CDPRODUTO,
                   V_CDPRODUTO, V_DSPRODEMIS, 'S', V_VRQUANTIDADE,
                   V_VRUNITARIO, 0, V_VRTOTALITEM, V_VRTOTALITEM,
                   V_VRTOTALITEM, 'S', V_CDFILIAL,
                   ' ', ' ', ' ', ' ',
                   V_CDPRODUTO, V_NRAUTOFORN, V_CDMARCA, V_DTPROGENTAF);

               INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM, IDTIPOMOVI, CDPRODUTO, QTTOTLANCTO, VRUNILANCTO,
                   VRTOTLANCTO, DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST, VRLANCTOBRUT, VRLANCTOEST,
                   CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
               VALUES
                  (V_CDFILIAL, V_NRLANCESTQ, V_NRSEQUITEM, '4', V_CDPRODUTO, V_VRQUANTIDADE, V_VRUNITARIO,
                   V_VRTOTALITEM, V_DTSAIDA, '9', V_CDPRODUTO, V_VRQUANTIDADE, V_VRUNITARIO, V_VRUNITARIO,
                   V_CDFILIAL, ' ', ' ', ' ', ' ');

               INSERT INTO ITEMNOTAFISC
                  (CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
               VALUES
                  (V_CDFILIAL, V_NRLANCTONF, V_NRSEQDEVOL, V_CDFILIALIT, V_NRLANCTONFIT);

               UPDATE USR_CISDEVO_COMPRA
                  SET NRLANCESTQ = V_NRLANCESTQ
                WHERE CDCENTCUST   = V_CDCENTCUST
                  AND NRNOTAFISCAL = V_NRNOTAFISCAL
                  AND CDFORNECED   = V_CDFORNECED
                  AND NRAUTOFORNE  = V_NRAUTOFORNE
                  AND CDPRODUTO    = V_CDPRODUTO;

            EXCEPTION
               WHEN OTHERS THEN
                  V_ERRO := SQLERRM(SQLCODE);
                  P_MENSAGEMERRO := V_ERRO;
            END;

            IF (V_ERRO IS NULL) THEN
               BEGIN
                  CIS_NF_DEVO_AF(V_CDFILIAL, V_NRLANCTONF, V_CDPRODUTO, V_NRSEQUITEM, V_VRQUANTIDADE, V_VRUNITARIO);
               EXCEPTION
                  WHEN OTHERS THEN
                     V_ERRO := SQLERRM(SQLCODE);
                     P_MENSAGEMERRO := V_ERRO;
               END;
            END IF;
         END IF;

      END LOOP;
      CLOSE C_PRODUTONF;

      BEGIN
         BAIXAAF(V_CDFILIAL, V_CDFILIAL, V_NRAUTOFORN); -- nao pode ficar no loop de produto
         CUSTO_LIQUIDO(V_CDFILIAL, V_NRLANCESTQ, 0, 0, 'S'); -- nao pode ficar no loop de produto
         ATUALIZA_ESTOQUE(V_CDFILIAL, V_DTSAIDA, SYSDATE, V_CDFILIAL, V_NRLANCESTQ, NULL); -- nao pode ficar no loop de produto
      EXCEPTION
         WHEN OTHERS THEN
            V_ERRO := SQLERRM(SQLCODE);
            P_MENSAGEMERRO := V_ERRO;
      END;

      IF (V_ERRO IS NULL) THEN

         UPDATE USR_CISDEVO_COMPRA
            SET DTIMPORTACAO = SYSDATE,
                HRIMPORTACAO = TO_CHAR(SYSDATE, 'HH:MM'),
                LOG_ERRO     = V_ERRO||' ERRO AF: '||P_IDERROAF
          WHERE CDCENTCUST   = V_CDCENTCUST
            AND NRNOTAFISCAL = V_NRNOTAFISCAL
            AND CDFORNECED   = V_CDFORNECED;

         COMMIT;
      ELSE
         V_ERRO := V_ERRO||P_IDERROAF;
         P_MENSAGEMERRO := V_ERRO;
         ROLLBACK;
      END IF;

   END LOOP;
   CLOSE C_NOTAS;
EXCEPTION
   WHEN OTHERS THEN
      V_ERRO := SQLERRM(SQLCODE);
      P_MENSAGEMERRO := V_ERRO;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_PROT_IMPORTA_DEVOCOMPRA','6.35.038'); END;
/
