/* Tabela INSPECPROD*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela INSPECPROD*/
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela INSPECPROD, utilizando a tabela Geral de Logs de Operaes */

IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_CDP_INSPECPROD' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_CDP_INSPECPROD
GO
CREATE TRIGGER LOG_CDP_INSPECPROD
ON INSPECPROD
FOR UPDATE,INSERT, DELETE
AS
BEGIN
  DECLARE @V_USUARIO             VARCHAR(40);
  DECLARE @V_TIPO                VARCHAR(1);
  DECLARE @V_TPMOVI              VARCHAR(1);
  DECLARE @V_ITPESQ              VARCHAR(40);
  DECLARE @V_DESC                VARCHAR(500);
  DECLARE @V_CDFILLOGOPER        VARCHAR(4);
  DECLARE @V_DSREMOTEADDR        VARCHAR(15);
  DECLARE @V_DSREMOTEHOST        VARCHAR(15);
  DECLARE @V_DSSERVERRDM         VARCHAR(20);
  DECLARE @V_DSSERVMETHOD        VARCHAR(30);
  DECLARE @V_DSREMOTEOPER        VARCHAR(12);
  DECLARE @V_DTOPER              DATETIME;

  DECLARE @V_CDPRODUTO_NEW       VARCHAR2(10);
  DECLARE @V_CDINSPECAO_NEW      VARCHAR2(10);
  DECLARE @V_NRSEQINSPRO_NEW     VARCHAR2(3);
  DECLARE @V_IDIMPINSPRO_NEW     VARCHAR2(1);
  DECLARE @V_CDSETOR_NEW         VARCHAR2(4);
  DECLARE @V_IDPROCPROD_NEW      VARCHAR2(1);
  DECLARE @V_DTULTATUINPR_NEW    DATE;
  DECLARE @V_IDSTATUSINSPEC_NEW  VARCHAR2(1);
  
  DECLARE @V_CDPRODUTO_OLD       VARCHAR2(10);
  DECLARE @V_CDINSPECAO_OLD      VARCHAR2(10);
  DECLARE @V_NRSEQINSPRO_OLD     VARCHAR2(3);
  DECLARE @V_IDIMPINSPRO_OLD     VARCHAR2(1);
  DECLARE @V_CDSETOR_OLD         VARCHAR2(4);
  DECLARE @V_IDPROCPROD_OLD      VARCHAR2(1);
  DECLARE @V_DTULTATUINPR_OLD    DATE;
  DECLARE @V_IDSTATUSINSPEC_OLD  VARCHAR2(1);
  
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';
   SET @V_USUARIO = '-';  

   DECLARE C_CURSOR_R CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
         CDPRODUTO,
         CDINSPECAO,
         NRSEQINSPRO,
         IDIMPINSPRO,
         CDSETOR,
         IDPROCPROD,
         DTULTATUINPR,
         IDSTATUSINSPEC
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDPRODUTO,
         INSERTED.CDINSPECAO,
         INSERTED.NRSEQINSPRO,
         INSERTED.IDIMPINSPRO,
         INSERTED.CDSETOR,
         INSERTED.IDPROCPROD,
         INSERTED.DTULTATUINPR,
         INSERTED.IDSTATUSINSPEC,
        
         DELETED.CDPRODUTO,
         DELETED.CDINSPECAO,
         DELETED.NRSEQINSPRO,
         DELETED.IDIMPINSPRO,
         DELETED.CDSETOR,
         DELETED.IDPROCPROD,
         DELETED.DTULTATUINPR,
         DELETED.IDSTATUSINSPEC

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDINSPECAO = DELETED.CDINSPECAO AND
         INSERTED.CDRESPINSPEC = DELETED.CDRESPINSPEC

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.CDPRODUTO,
         INSERTED.CDINSPECAO,
         INSERTED.NRSEQINSPRO,
         INSERTED.IDIMPINSPRO,
         INSERTED.CDSETOR,
         INSERTED.IDPROCPROD,
         INSERTED.DTULTATUINPR,
         INSERTED.IDSTATUSINSPEC,

         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL,
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)
         
   OPEN C_CURSOR_R;
   FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                   @V_CDPRODUTO_NEW, @V_CDINSPECAO_NEW, @V_NRSEQINSPRO_NEW, @V_IDIMPINSPRO_NEW,@V_CDSETOR_NEW,
                                   @V_IDPROCPROD_NEW, @V_DTULTATUINPR_NEW, @V_IDSTATUSINSPEC_NEW

                                   @V_CDPRODUTO_OLD, @V_CDINSPECAO_OLD, @V_NRSEQINSPRO_OLD, @V_IDIMPINSPRO_OLD,@V_CDSETOR_OLD,
                                   @V_IDPROCPROD_OLD, @V_DTULTATUINPR_OLD, @V_IDSTATUSINSPEC_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN
   

      IF @V_TIPO = 'D' BEGIN
      
         IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Produto = ' + ISNULL(@V_CDPRODUTO_OLD,'') + ' ';
         END;
         IF @V_CDINSPECAO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Inspeo = ' + ISNULL(@V_CDINSPECAO_OLD,'') + ' ';
         END;
         IF @V_NRSEQINSPRO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Sequencial = ' + ISNULL(@V_NRSEQINSPRO_OLD,'') + ' ';
         END;
         IF @V_IDIMPINSPRO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Impeditiva = ' + ISNULL(@V_IDIMPINSPRO_OLD,'') + ' ';
         END;
         IF @V_CDSETOR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Setor = ' + ISNULL(@V_CDSETOR_OLD,'') + ' ';
         END;
         IF @V_IDPROCPROD_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de Material = ' + ISNULL(@V_IDPROCPROD_OLD,'') + ' ';
         END;
         IF @V_DTULTATUINPR_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'ltima Alterao = ' + ISNULL(@V_DTULTATUINPR_OLD,'') + ' ';
         END;
         IF @V_IDSTATUSINSPEC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Situao = ' + ISNULL(@V_IDSTATUSINSPEC_OLD,'') + ' ';
         END;      
      
         SET @V_TPMOVI = '3';
         SET @V_ITPESQ = @V_CDPRODUTO_OLD + @V_CDINSPECAO_OLD + @V_NRSEQINSPRO_OLD; 
      END
      ELSE BEGIN
         IF @V_TIPO = 'U' BEGIN
            IF (@V_CDPRODUTO_OLD      <> @V_CDPRODUTO_NEW     ) OR
               (@V_CDINSPECAO_OLD     <> @V_CDINSPECAO_NEW    ) OR
               (@V_NRSEQINSPRO_OLD    <> @V_NRSEQINSPRO_NEW   ) OR
               (@V_IDIMPINSPRO_OLD    <> @V_IDIMPINSPRO_NEW   ) OR
               (@V_CDSETOR_OLD        <> @V_CDSETOR_NEW       ) OR
               (@V_IDPROCPROD_OLD     <> @V_IDPROCPROD_NEW    ) OR
               (@V_DTULTATUINPR_OLD   <> @V_DTULTATUINPR_NEW  ) OR
               (@V_IDSTATUSINSPEC_OLD <> @V_IDSTATUSINSPEC_NEW) BEGIN

               SET @V_TPMOVI = '2';
               SET @V_ITPESQ = @V_CDPRODUTO_OLD + @V_CDINSPECAO_OLD + @V_NRSEQINSPRO_OLD; 
            END;
         END
         ELSE BEGIN
            SET @V_TPMOVI = '1';
            SET @V_ITPESQ = @V_CDPRODUTO_NEW + @V_CDINSPECAO_NEW + @V_NRSEQINSPRO_NEW; 
         END;
         
         IF ISNULL(@V_CDPRODUTO_NEW, '!') <> ISNULL(@V_CDPRODUTO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Produto = ' + @V_CDPRODUTO_NEW;
         END;
         IF ISNULL(@V_CDINSPECAO_NEW, '!') <> ISNULL(@V_CDINSPECAO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Inspeo = ' + @V_CDINSPECAO_NEW;
         END;
         IF ISNULL(@V_NRSEQINSPRO_NEW, '!') <> ISNULL(@V_NRSEQINSPRO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Sequencial = ' + @V_NRSEQINSPRO_NEW;
         END;
         IF ISNULL(@V_IDIMPINSPRO_NEW, '!') <> ISNULL(@V_IDIMPINSPRO_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Impeditiva = ' + @V_IDIMPINSPRO_NEW;
         END;
         IF ISNULL(@V_CDSETOR_NEW, '!') <> ISNULL(@V_CDSETOR_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Setor = ' + @V_CDSETOR_NEW;
         END;
         IF ISNULL(@V_IDPROCPROD_NEW, '!') <> ISNULL(@V_IDPROCPROD_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Tipo de Material = ' + @V_IDPROCPROD_NEW;
         END;
         IF ISNULL(@V_DTULTATUINPR_NEW, '!') <> ISNULL(@V_DTULTATUINPR_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'ltima Alterao = ' + @V_DTULTATUINPR_NEW;
         END;
         IF ISNULL(@V_IDSTATUSINSPEC_NEW, '!') <> ISNULL(@V_IDSTATUSINSPEC_OLD, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Situao = ' + @V_IDSTATUSINSPEC_NEW;
         END;
         
      END;
      IF @V_TPMOVI <> '0' BEGIN
         EXEC NMUSUARIO  @V_USUARIO;
         EXEC WEBTUNNING @V_DSREMOTEADDR,
                         @V_DSREMOTEHOST,
                         @V_DSSERVERRDM,
                         @V_DSSERVMETHOD,
                         @V_DSREMOTEOPER;
         IF NOT @V_DESC IS NULL BEGIN

            SET @V_DTOPER = GETDATE();

            INSERT INTO LOGOPERA
               (NMTABELA,
                DTOPERACAO,
                NMRESPOPER,
                IDTIPOOPER,
                CDPESQITEM,
                DSOPERACAO,
                CDFILLOGOPER,
                DSRDMUSUOPER,
                DSENDUSUOPER,
                DSNMUSUOPER,
                DSMETUSUOPER,
                CDORESPOPER)
            VALUES
               ('INSPECPROD',
                @V_DTOPER,
                @V_USUARIO,
                @V_TPMOVI,
                @V_ITPESQ,
                SUBSTRING(@V_DESC,1,300),
                @V_CDFILLOGOPER,
                @V_DSSERVERRDM,
                @V_DSREMOTEADDR,
                @V_DSREMOTEHOST,
                @V_DSSERVMETHOD,
                @V_DSREMOTEOPER);

         END;
      END;
      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO,
                                   @V_CDPRODUTO_NEW, @V_CDINSPECAO_NEW, @V_NRSEQINSPRO_NEW, @V_IDIMPINSPRO_NEW,@V_CDSETOR_NEW,
                                   @V_IDPROCPROD_NEW, @V_DTULTATUINPR_NEW, @V_IDSTATUSINSPEC_NEW

                                   @V_CDPRODUTO_OLD, @V_CDINSPECAO_OLD, @V_NRSEQINSPRO_OLD, @V_IDIMPINSPRO_OLD,@V_CDSETOR_OLD,
                                   @V_IDPROCPROD_OLD, @V_DTULTATUINPR_OLD, @V_IDSTATUSINSPEC_OLD;
   END;
   CLOSE C_CURSOR_R;
   DEALLOCATE C_CURSOR_R;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CDP_INSPECPROD','5.85.XXX';
GO