create or replace PROCEDURE FCT_RECRIA_MEDICAO_CONTRATO (
    P_NRSEQCONTRATO        IN INTEGER,
    P_NRORG                IN INTEGER)
  AS 
  
    V_NRSEQCONTRATO_OLD  NUMBER;
    V_VRUNITARIO         NUMBER; 
    V_QTMEDIDACONTR      NUMBER; 
	V_VRPRECOVARIACAO    NUMBER;
	V_VRMEDICAOAUX       NUMBER;
    V_VRMEDICAO          NUMBER;
	V_VRMEDICAODESC      NUMBER;
    V_NRITEMELEMENTO     NUMBER;
    V_IDTIPODESC         VARCHAR2(2);
	V_VRDESCONTO	     NUMBER;
	V_PERCDESCONTO       NUMBER;
	V_IDTIPODESCNEG      VARCHAR2(2);
	V_VRDESCONTONEG	     NUMBER;
	V_VRMEDICAODESCNEG   NUMBER;
	V_VRTOTALMEDDESC     NUMBER;
	V_DESCPERIODO        NUMBER;
	V_NRPARCELASNEGCONTR NUMBER;

BEGIN

	BEGIN
		SELECT MAX(NRSEQCONTRATOPAI)
		  INTO V_NRSEQCONTRATO_OLD
		  FROM FCT_CONTRATO
		 WHERE NRSEQCONTRATO = P_NRSEQCONTRATO
		   AND NRORG = P_NRORG;
	EXCEPTION
		WHEN NO_DATA_FOUND THEN
			V_NRSEQCONTRATO_OLD := NULL;
	END;

	FOR C_COLETA IN (SELECT NRSEQCONTRATO, NRPARCFATURA, IDELEMENTORAIZ, CDSERVORCA, CDTPMEDIDAVARIAVEL,
                            DTINICOMPET, DTFINCOMPET, QTMEDIDAVARIAVEL, QTMEDIDAMEDICAO, DTCOLETAVALIDAOM,
                            QTMEDIDAVALIDAOM, DTULTIMACOLETAOM, QTULTIMAMEDIDAOM, VRITEMCONT, VRITEMCONTCOMDESC,
						    ORIGEMCOLETA, IDMULTIPVARIACAO
			           FROM TMP_FCT_COLETAMEDICAOFATURA
				      WHERE (((ORIGEMCOLETA = 'RENOVACAO') AND (NRSEQCONTRATO = P_NRSEQCONTRATO)) 
				            OR ((ORIGEMCOLETA = 'RENEGOCIACAO') AND (NRSEQCONTRATO = V_NRSEQCONTRATO_OLD)))
				        AND NRORG = P_NRORG) LOOP

			FOR C_MED IN (SELECT MED.NRMEDICAOFATURA, MEDVAR.NRMEDVARMEDICAOFATURA
							FROM FCT_MEDICAOFATURA MED
							JOIN FCT_MEDVARMEDICAOFATURA MEDVAR
							  ON MEDVAR.NRMEDICAOFATURA  = MED.NRMEDICAOFATURA
						   WHERE MED.NRSEQCONTRATO = P_NRSEQCONTRATO
							 AND MED.NRPARCFATURA = C_COLETA.NRPARCFATURA
							 AND TO_CHAR(MED.DTFINCOMPET, 'MM/YYYY') = TO_CHAR(C_COLETA.DTFINCOMPET, 'MM/YYYY')
							 AND MEDVAR.CDSERVORCA = C_COLETA.CDSERVORCA
							 AND MEDVAR.IDELEMENTORAIZ = C_COLETA.IDELEMENTORAIZ
							 AND MEDVAR.CDTPMEDIDAVARIAVEL = C_COLETA.CDTPMEDIDAVARIAVEL
							 AND MED.NRORG = P_NRORG) LOOP


				IF (C_COLETA.ORIGEMCOLETA = 'RENOVACAO') THEN

					BEGIN
						SELECT NRITEMOCONTRATO
						  INTO V_NRITEMELEMENTO
						  FROM FCT_ITEMCONTRATO
						 WHERE NRSEQCONTRATO = P_NRSEQCONTRATO
						   AND CDSERVORCA = C_COLETA.CDSERVORCA
						   AND IDELEMENTO = C_COLETA.IDELEMENTORAIZ
						   AND CDTPMEDIDAVARIAVEL =  C_COLETA.CDTPMEDIDAVARIAVEL
						   AND NRORG = P_NRORG;
					EXCEPTION
						WHEN NO_DATA_FOUND THEN 
							V_NRITEMELEMENTO := NULL;
					END;

					IF (V_NRITEMELEMENTO IS NOT NULL) THEN

					    V_VRMEDICAO := C_COLETA.VRITEMCONTCOMDESC;

						V_NRPARCELASNEGCONTR := NULL;
						V_VRMEDICAODESCNEG := NULL;
						
						FOR C_NEGOCIA IN (SELECT NEGOCIA.IDTIPONEGOCIA, PARC.VRPARCELANEGOCIA, PARC.NRPARCELASNEGCONTR
							  FROM FCT_NEGCONTRATO NEGOCIA
							  JOIN FCT_PARCELASNEGCONTR PARC
								ON PARC.NRNEGCONTRATO = NEGOCIA.NRNEGCONTRATO
							   AND PARC.NRORG = NEGOCIA.NRORG 
							 WHERE NEGOCIA.NRSEQCONTRATO = P_NRSEQCONTRATO
							   AND NEGOCIA.NRPARCNEGOCIO = C_COLETA.NRPARCFATURA
							   AND NEGOCIA.NRITEMELEMENTO = V_NRITEMELEMENTO
							   AND C_COLETA.DTFINCOMPET BETWEEN DTINIPARCNEGOCIA AND DTFIMPARCNEGOCIA
							   AND NEGOCIA.NRORG = P_NRORG) LOOP
							   
							IF (C_NEGOCIA.IDTIPONEGOCIA IS NOT NULL) THEN
							
								V_NRPARCELASNEGCONTR := C_NEGOCIA.NRPARCELASNEGCONTR;
								
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'VF' THEN -- Valor Fixo
									V_VRMEDICAODESCNEG := C_NEGOCIA.VRPARCELANEGOCIA;
								END IF;
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'DP' THEN -- Desconto (Percentual)
									V_VRMEDICAODESCNEG := V_VRMEDICAO - ((V_VRMEDICAO*C_NEGOCIA.VRPARCELANEGOCIA)/100);
								END IF;
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'DV' THEN  -- Desconto (Valor)
									V_VRMEDICAODESCNEG := V_VRMEDICAO - C_NEGOCIA.VRPARCELANEGOCIA;
								END IF;
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'AP' THEN -- Acrscimo (Percentual)
									V_VRMEDICAODESCNEG := V_VRMEDICAO + ((V_VRMEDICAO*C_NEGOCIA.VRPARCELANEGOCIA)/100);
								END IF;
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'AV' THEN-- Acrscimo (Valor)
									V_VRMEDICAODESCNEG := V_VRMEDICAO + C_NEGOCIA.VRPARCELANEGOCIA;
								END IF;

							ELSE 
								V_NRPARCELASNEGCONTR := NULL;
								V_VRMEDICAODESCNEG := NULL;
							END IF;
						
						END LOOP;


						UPDATE FCT_MEDVARMEDICAOFATURA
						   SET QTMEDIDAVARIAVEL   = C_COLETA.QTMEDIDAVARIAVEL,
							   QTMEDIDAMEDICAO    = C_COLETA.QTMEDIDAMEDICAO,
							   DTCOLETAVALIDAOM   = C_COLETA.DTCOLETAVALIDAOM,
							   QTMEDIDAVALIDAOM   = C_COLETA.QTMEDIDAVALIDAOM,
							   DTULTIMACOLETAOM   = C_COLETA.DTULTIMACOLETAOM,
							   QTULTIMAMEDIDAOM   = C_COLETA.QTULTIMAMEDIDAOM,
							   VRITEMCONT         = C_COLETA.VRITEMCONT,
							   VRITEMCONTCOMDESC  = C_COLETA.VRITEMCONTCOMDESC,
							   VRNEGCONTR         = V_VRMEDICAODESCNEG,
							   NRPARCELASNEGCONTR = V_NRPARCELASNEGCONTR
						 WHERE NRMEDVARMEDICAOFATURA = C_MED.NRMEDVARMEDICAOFATURA
						   AND NRMEDICAOFATURA = C_MED.NRMEDICAOFATURA
						   AND NRORG = P_NRORG;

					END IF;

				ELSE 

					BEGIN
						SELECT NRITEMOCONTRATO, VRUNITITEMCONT, QTMEDIDACONTR  
						  INTO V_NRITEMELEMENTO, V_VRUNITARIO, V_QTMEDIDACONTR
						  FROM FCT_ITEMCONTRATO
						 WHERE NRSEQCONTRATO = P_NRSEQCONTRATO
						   AND CDSERVORCA = C_COLETA.CDSERVORCA
						   AND IDELEMENTO = C_COLETA.IDELEMENTORAIZ
						   AND CDTPMEDIDAVARIAVEL =  C_COLETA.CDTPMEDIDAVARIAVEL
						   AND NRORG = P_NRORG;
					EXCEPTION
						WHEN NO_DATA_FOUND THEN BEGIN
							V_NRITEMELEMENTO := NULL;
							V_VRUNITARIO := NULL;
							V_QTMEDIDACONTR := NULL;
						END;
					END;

					IF (V_NRITEMELEMENTO IS NOT NULL) THEN

						BEGIN 
							SELECT VRPRECOVARIACAO
							  INTO V_VRPRECOVARIACAO
							  FROM FCT_VARPRECBASESERVCONT
							 WHERE NRSEQCONTRATO = P_NRSEQCONTRATO
							   AND CDSERVORCA = C_COLETA.CDSERVORCA
							   AND CDTPMEDIDAVARIAVEL =  C_COLETA.CDTPMEDIDAVARIAVEL
							   AND C_COLETA.QTMEDIDAMEDICAO BETWEEN QTMEDIDAINIVARIACAO AND QTMEDIDAFIMVARIACAO
							   AND NRORG = P_NRORG;
						EXCEPTION
						   WHEN NO_DATA_FOUND THEN
								V_VRPRECOVARIACAO := NULL;
						END;

						IF V_VRPRECOVARIACAO IS NOT NULL THEN
							V_VRMEDICAOAUX := V_VRPRECOVARIACAO;
						ELSE
							V_VRMEDICAOAUX := V_VRUNITARIO;
						END IF;

						IF (C_COLETA.IDMULTIPVARIACAO = 'S') THEN

							IF (V_QTMEDIDACONTR > C_COLETA.QTMEDIDAMEDICAO) THEN

								V_VRMEDICAO := V_VRMEDICAOAUX*V_QTMEDIDACONTR;
							ELSE 
								V_VRMEDICAO := V_VRMEDICAOAUX*C_COLETA.QTMEDIDAMEDICAO;
							END IF;
						ELSE
							V_VRMEDICAO := V_VRMEDICAOAUX;
						END IF;

						BEGIN 
							SELECT IDTPDESCONTO , VRDESCITEM, VRPERCDESCITEM     
							  INTO V_IDTIPODESC, V_VRDESCONTO, V_PERCDESCONTO 
							  FROM FCT_ITNEGOCIACAOCONTRATO 
							 WHERE NRITEMOCONTRATO = V_NRITEMELEMENTO
							   AND NRPARCFATURA = C_COLETA.NRPARCFATURA
							   AND CDSERVORCA = C_COLETA.CDSERVORCA
							   AND NRORG = P_NRORG;
						EXCEPTION
							WHEN NO_DATA_FOUND THEN BEGIN
								V_IDTIPODESC   := NULL;
								V_VRDESCONTO   := NULL;
								V_PERCDESCONTO := NULL;
							END;
						END;

						IF (V_IDTIPODESC IS NOT NULL) THEN
							IF (V_IDTIPODESC = 'V') THEN
								V_VRMEDICAO := V_VRMEDICAO - V_VRDESCONTO;
							ELSE
								V_VRMEDICAO := V_VRMEDICAO - (V_VRMEDICAO * V_PERCDESCONTO/100);
							END IF;
						ELSE 
							V_VRMEDICAODESC := V_VRMEDICAO;
						END IF;

						V_NRPARCELASNEGCONTR := NULL;
						V_VRMEDICAODESCNEG := NULL;
						
						FOR C_NEGOCIA IN (SELECT NEGOCIA.IDTIPONEGOCIA, PARC.VRPARCELANEGOCIA, PARC.NRPARCELASNEGCONTR
							  FROM FCT_NEGCONTRATO NEGOCIA
							  JOIN FCT_PARCELASNEGCONTR PARC
								ON PARC.NRNEGCONTRATO = NEGOCIA.NRNEGCONTRATO
							   AND PARC.NRORG = NEGOCIA.NRORG 
							 WHERE NEGOCIA.NRSEQCONTRATO = P_NRSEQCONTRATO
							   AND NEGOCIA.NRPARCNEGOCIO = C_COLETA.NRPARCFATURA
							   AND NEGOCIA.NRITEMELEMENTO = V_NRITEMELEMENTO
							   AND C_COLETA.DTFINCOMPET BETWEEN DTINIPARCNEGOCIA AND DTFIMPARCNEGOCIA
							   AND NEGOCIA.NRORG = P_NRORG) LOOP
							   
							IF (C_NEGOCIA.IDTIPONEGOCIA IS NOT NULL) THEN
							
								V_NRPARCELASNEGCONTR := C_NEGOCIA.NRPARCELASNEGCONTR;
								
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'VF' THEN -- Valor Fixo
									V_VRMEDICAODESCNEG := C_NEGOCIA.VRPARCELANEGOCIA;
								END IF;
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'DP' THEN -- Desconto (Percentual)
									V_VRMEDICAODESCNEG := V_VRMEDICAO - ((V_VRMEDICAO*C_NEGOCIA.VRPARCELANEGOCIA)/100);
								END IF;
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'DV' THEN  -- Desconto (Valor)
									V_VRMEDICAODESCNEG := V_VRMEDICAO - C_NEGOCIA.VRPARCELANEGOCIA;
								END IF;
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'AP' THEN -- Acrscimo (Percentual)
									V_VRMEDICAODESCNEG := V_VRMEDICAO + ((V_VRMEDICAO*C_NEGOCIA.VRPARCELANEGOCIA)/100);
								END IF;
								IF C_NEGOCIA.IDTIPONEGOCIA  = 'AV' THEN-- Acrscimo (Valor)
									V_VRMEDICAODESCNEG := V_VRMEDICAO + C_NEGOCIA.VRPARCELANEGOCIA;
								END IF;

							ELSE 
								V_NRPARCELASNEGCONTR := NULL;
								V_VRMEDICAODESCNEG := NULL;
							END IF;
						
						END LOOP;

						UPDATE FCT_MEDVARMEDICAOFATURA
						   SET QTMEDIDAVARIAVEL   = C_COLETA.QTMEDIDAVARIAVEL,
							   QTMEDIDAMEDICAO    = C_COLETA.QTMEDIDAMEDICAO,
							   DTCOLETAVALIDAOM   = C_COLETA.DTCOLETAVALIDAOM,
							   QTMEDIDAVALIDAOM   = C_COLETA.QTMEDIDAVALIDAOM,
							   DTULTIMACOLETAOM   = C_COLETA.DTULTIMACOLETAOM,
							   QTULTIMAMEDIDAOM   = C_COLETA.QTULTIMAMEDIDAOM,
							   VRITEMCONT         = V_VRMEDICAO,
							   VRITEMCONTCOMDESC  = V_VRMEDICAODESC,
							   VRNEGCONTR         = V_VRMEDICAODESCNEG,
							   NRPARCELASNEGCONTR = V_NRPARCELASNEGCONTR
						 WHERE NRMEDVARMEDICAOFATURA = C_MED.NRMEDVARMEDICAOFATURA
						   AND NRMEDICAOFATURA = C_MED.NRMEDICAOFATURA
						   AND NRORG = P_NRORG;

					END IF;

				END IF;

				FOR C_ITEM IN (SELECT SUM(NVL(VRITEMCONTCOMDESC,0)) VRTOTALMED
								 FROM FCT_MEDVARMEDICAOFATURA
								WHERE NRMEDICAOFATURA = C_MED.NRMEDICAOFATURA
							   	  AND CDSERVORCA = C_COLETA.CDSERVORCA
								  AND NRORG = P_NRORG) LOOP

					BEGIN 
						SELECT DISTINCT NEG.IDTPDESCONTO, NEG.VRDESCITEM, NEG.VRPERCDESCITEM     
						  INTO V_IDTIPODESC, V_VRDESCONTO, V_PERCDESCONTO 
						  FROM FCT_NEGOCIACAOCONTRATO NEG
						  JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
						    ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
						   AND ITNEG.NRORG = NEG.NRORG
						 WHERE NEG.NRSEQCONTRATO = P_NRSEQCONTRATO
						   AND NEG.NRPARCFATURA = C_COLETA.NRPARCFATURA
						   AND ITNEG.CDSERVORCA = C_COLETA.CDSERVORCA
						   AND NEG.NRORG = P_NRORG;
					EXCEPTION
						WHEN NO_DATA_FOUND THEN BEGIN
							V_IDTIPODESC   := NULL;
							V_VRDESCONTO   := NULL;
							V_PERCDESCONTO := NULL;
						END;
					END;
                    
                    IF (V_IDTIPODESC IS NOT NULL) THEN
                        IF (V_IDTIPODESC = 'V') THEN
                            V_VRTOTALMEDDESC := C_ITEM.VRTOTALMED - V_VRDESCONTO;
                        ELSE
                            V_VRTOTALMEDDESC := C_ITEM.VRTOTALMED - (C_ITEM.VRTOTALMED * V_PERCDESCONTO/100);
                        END IF;
                    ELSE 
                        V_VRTOTALMEDDESC := C_ITEM.VRTOTALMED;
                    END IF;

					BEGIN
						SELECT DESCPER.VRPERCDESCITEM
						  INTO V_DESCPERIODO
						  FROM FCT_DESCPERIODONEGOCONT DESCPER
						  JOIN FCT_NEGOCIACAOCONTRATO NEG
							ON NEG.NRNEGOCIACAOCONTRATO = DESCPER.NRNEGOCIACAOCONTRATO
						   AND NEG.NRORG = DESCPER.NRORG
						 WHERE NEG.NRPARCFATURA = C_COLETA.NRPARCFATURA
						   AND NEG.NRSEQCONTRATO = P_NRSEQCONTRATO
						   AND NEG.NRORG = P_NRORG
						   AND DTFINALVALIDADEDESC >= LAST_DAY(C_COLETA.DTFINCOMPET)
						   AND DTFINALVALIDADEDESC IS NOT NULL
						   AND DTFINALVALIDADEDESC = (SELECT MIN(DTFINALVALIDADEDESC)
														FROM FCT_DESCPERIODONEGOCONT DESCPER
														JOIN FCT_NEGOCIACAOCONTRATO NEG
														  ON NEG.NRNEGOCIACAOCONTRATO = DESCPER.NRNEGOCIACAOCONTRATO
														 AND NEG.NRORG = DESCPER.NRORG
														WHERE NEG.NRPARCFATURA = C_COLETA.NRPARCFATURA
														  AND NEG.NRSEQCONTRATO = P_NRSEQCONTRATO
														  AND NEG.NRORG = P_NRORG
														  AND DTFINALVALIDADEDESC >= LAST_DAY(C_COLETA.DTFINCOMPET)
														  AND DTFINALVALIDADEDESC IS NOT NULL);
					EXCEPTION
						WHEN NO_DATA_FOUND THEN
							V_DESCPERIODO := 0;
					END;

					IF (V_DESCPERIODO > 0) THEN
						V_VRTOTALMEDDESC := V_VRTOTALMEDDESC - ((V_VRTOTALMEDDESC*V_DESCPERIODO)/100);
					END IF;
					
					V_NRPARCELASNEGCONTR := NULL;
					V_VRMEDICAODESCNEG := NULL;
							
					FOR C_DESCNEG IN (SELECT NEGCONT.IDTIPONEGOCIA, PARCNEGCT.VRPARCELANEGOCIA, PARCNEGCT.NRPARCELASNEGCONTR
										FROM FCT_NEGCONTRATO NEGCONT
										JOIN FCT_PARCELASNEGCONTR PARCNEGCT
										  ON PARCNEGCT.NRNEGCONTRATO = NEGCONT.NRNEGCONTRATO
										 AND PARCNEGCT.NRORG = NEGCONT.NRORG
									   WHERE NEGCONT.IDREALIZARNEGOCIACAO = 'M'
									     AND NEGCONT.NRITEMELEMENTO IS NULL
										 AND ((NEGCONT.NRSEQCONTRATO = P_NRSEQCONTRATO AND NEGCONT.NRAGRUPAMENTO IS NULL) 
										  OR (NEGCONT.NRSEQCONTRATO IS NULL AND NEGCONT.NRAGRUPAMENTO = (SELECT NRAGRUPAMENTO 
																										   FROM FCT_RELACAGRUPAMENTOCONT
																										  WHERE NRSEQCONTRATO = P_NRSEQCONTRATO))) 
										 AND C_COLETA.DTFINCOMPET BETWEEN DTINIPARCNEGOCIA AND DTFIMPARCNEGOCIA
										 AND NEGCONT.NRORG = P_NRORG) LOOP

						IF (C_DESCNEG.IDTIPONEGOCIA IS NOT NULL) THEN

							V_NRPARCELASNEGCONTR := C_DESCNEG.NRPARCELASNEGCONTR;

							IF C_DESCNEG.IDTIPONEGOCIA = 'VF' THEN -- Valor Fixo
								V_VRMEDICAODESCNEG :=  C_DESCNEG.VRPARCELANEGOCIA;
							END IF;
							IF C_DESCNEG.IDTIPONEGOCIA = 'DP' THEN -- Desconto (Percentual)
								V_VRMEDICAODESCNEG := V_VRTOTALMEDDESC - ((V_VRTOTALMEDDESC*C_DESCNEG.VRPARCELANEGOCIA)/100);
							END IF;
							IF C_DESCNEG.IDTIPONEGOCIA = 'DV' THEN  -- Desconto (Valor)
								V_VRMEDICAODESCNEG := V_VRTOTALMEDDESC - C_DESCNEG.VRPARCELANEGOCIA;
							END IF;
							IF C_DESCNEG.IDTIPONEGOCIA = 'AP' THEN -- Acrscimo (Percentual)
								V_VRMEDICAODESCNEG := V_VRTOTALMEDDESC + ((V_VRTOTALMEDDESC*C_DESCNEG.VRPARCELANEGOCIA)/100);
							END IF;
							IF C_DESCNEG.IDTIPONEGOCIA = 'AV' THEN-- Acrscimo (Valor)
								V_VRMEDICAODESCNEG := V_VRTOTALMEDDESC + C_DESCNEG.VRPARCELANEGOCIA;
							END IF;

						ELSE 
						    V_NRPARCELASNEGCONTR := NULL;
							V_VRMEDICAODESCNEG := NULL;
						END IF;

					END LOOP;

					UPDATE FCT_ITMEDICAOFATURA
					   SET VRTOTITEMCONT = C_ITEM.VRTOTALMED,
					       VRITEMCONT = V_VRTOTALMEDDESC,
						   IDSITUACAO = '3',
						   VRNEGCONTR = V_VRMEDICAODESCNEG,
						   NRPARCELASNEGCONTR = V_NRPARCELASNEGCONTR
					 WHERE NRMEDICAOFATURA = C_MED.NRMEDICAOFATURA
					   AND NRORG = P_NRORG;

					UPDATE FCT_MEDICAOFATURA
					   SET VRMEDICAO = V_VRTOTALMEDDESC,
						   IDSITUACAO = '3',
						   VRNEGCONTR = V_VRMEDICAODESCNEG,
						   NRPARCELASNEGCONTR = V_NRPARCELASNEGCONTR
					 WHERE NRMEDICAOFATURA = C_MED.NRMEDICAOFATURA
					   AND NRORG = P_NRORG;

				END LOOP;

			END LOOP;

			DELETE FROM TMP_FCT_COLETAMEDICAOFATURA
			WHERE NRSEQCONTRATO = C_COLETA.NRSEQCONTRATO 
			  AND NRPARCFATURA = C_COLETA.NRPARCFATURA 
			  AND IDELEMENTORAIZ = C_COLETA.IDELEMENTORAIZ 
			  AND CDSERVORCA = C_COLETA.CDSERVORCA
			  AND CDTPMEDIDAVARIAVEL = C_COLETA.CDTPMEDIDAVARIAVEL
              AND DTINICOMPET = C_COLETA.DTINICOMPET
			  AND DTFINCOMPET = C_COLETA.DTFINCOMPET
			  AND ORIGEMCOLETA = C_COLETA.ORIGEMCOLETA;

	END LOOP;

END;
/